//   Standard File

////////////////////////////////////////////////////
// RenriVer8.70  DllLibrary Arduino  0.01         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make webdns_kihon.ino File  2019/02/11 19:45     //
////////////////////////////////////////////////////
// device_list //
 // X0021 	X0023 	X0034 	X0035 	// XDevice = 4
 // Y0018 	Y0019 	Y0025 	Y0026 	// YDevice = 4 
 // M0000 	// MDevice = 1  
 // // DDevice = 0  
 // T0000 	T0001 	// TDevice = 2  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // device_list //

#include <WiFi.h>
#include <DNSServer.h>
#include <EEPROM.h>
#include "webdns_kihon.h";
const char *ssid = "ESP32_AP";
const char *password = "12345678";
const IPAddress local_ip(192, 168, 0, 25);
const IPAddress gateway(192, 168, 0, 1);
const IPAddress subnet(255, 255, 255, 0); 


void setup(){
	 byte		tmp;

	 int		count = 0;
	 Serial.begin(115200);	// 通信速度：115200bps,データ長8bit,ストップビット1bit,パリティなし
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	 readEEPROM(EEPROM_SIZE-32,32,myssid); // SSIDをＥＥＰＲＯＭから読み出し
	 readEEPROM(EEPROM_SIZE-64,32,mypassword); // PASSWORDをＥＥＰＲＯＭから読み出し
	 Serial.println();
	 WiFi.disconnect(true);
	 WiFi.mode(WIFI_MODE_AP);
	 WiFi.softAP(ssid, password);
	 delay(10);
	 WiFi.softAPConfig(local_ip, gateway, subnet);
	 delay(10);
	 IPAddress myIP = WiFi.softAPIP();
	 dnsServer.start(DNS_PORT, "*", local_ip);
	 server.begin(); // サーバーの受信待ち開始
	 xTaskCreatePinnedToCore(webpage, "webserver", 4096, NULL, 40, NULL, 1);
	 xTaskCreatePinnedToCore(scanloop, "scanloop", 4096, NULL, 10, NULL,1);
}

////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void scanloop(void *args){			// 

while(1){
	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 input_refresh();		// 入力更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0021,21);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND(03) 
	 flag = GET_X(X0023,23);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0018,18);
	 } else { 
	 	 SET_Y_OFF(Y0018,18);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0034,34);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR(05) 
	 flag = GET_X(X0035,35);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0019,19);
	 } else { 
	 	 SET_Y_OFF(Y0019,19);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0021,21);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND(03) 
	 flag = GET_X(X0023,23);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_E_ON(M9003,9003);
	 } else { 
	 	 SET_E_OFF(M9003,9003);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9003,9003);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND(03) 
	 flag = GET_X(X0034,34);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// AND(03) 
	 flag = GET_X(X0035,35);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0025,25);
	 } else { 
	 	 SET_Y_OFF(Y0025,25);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0021,21);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR(05) 
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI(04) 
	 flag = GET_X(X0023,23);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_M_ON(M0000,0);
	 } else { 
	 	 SET_M_OFF(M0000,0);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI(04) 
	 flag = GET_T(T0001,1);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// TIM(35) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0000,0)) { 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } else { 
	 	 	 if ((t_count[0] + (spantime) ) >=  5 * 100000){
	 	 	 	 t_count[0] = 5 * 100000; 
	 	 	 	 SET_T_ON(T0000,0);
	 	 	 } else {
	 	 	 	 t_count[0] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[0] = 0;
	 	 SET_T_OFF(T0000,0);
	 	 SET_UTRG_OFF(UTRG0000,0);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_T(T0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// TIM(35) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001,1)) { 
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } else { 
	 	 	 if ((t_count[1] + (spantime) ) >=  10 * 100000){
	 	 	 	 t_count[1] = 10 * 100000; 
	 	 	 	 SET_T_ON(T0001,1);
	 	 	 } else {
	 	 	 	 t_count[1] += spantime; 
	 	 	 }
	 	 }
	 } else {
	 	 t_count[1] = 0;
	 	 SET_T_OFF(T0001,1);
	 	 SET_UTRG_OFF(UTRG0001,1);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0000,0);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ANI(04) 
	 flag = GET_T(T0000,0);
	 if ( flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0026,26);
	 } else { 
	 	 SET_Y_OFF(Y0026,26);
	 }
	 
// END(10) 
	 output_refresh();	// 出力更新処理
	 while (Serial.available() > 0){
		 recv_data[nowpos] = Serial.read();
		 if (recv_data[nowpos] == '\n'){
			 recv_data[nowpos] = '\0'; 
			 strcpy(buf,recv_data); 
			 nowpos = 0;
			 Serial.println("");
			 Serial.println(buf);
			 break;
		 }

		 nowpos++;

		 if (nowpos >= 1024) {
			  nowpos = 0;
		 }
	 }

	 if (strlen(buf) > 0) {
		 if (strncmp(buf,"ssid=",5)==0){
			 strcpy(myssid,&buf[5]);
			 Serial.println(myssid);
		 } else if (strncmp(buf,"passwd=",7)==0){
			 strcpy(mypassword,&buf[7]);
		 } else if (strncmp(buf,"ssid?",5)==0){
			 Serial.println(myssid);
		} else if (strncmp(buf,"restart",7)==0){
			 Serial.println("再起動します。");    
			 ESP.restart();
		 } else if (strncmp(buf,"wifisave",8)==0){
			 Serial.print("SSID=");
			 Serial.println(myssid);
			 Serial.print("PASSWORD=");
			 Serial.println(mypassword);
			 Serial.println("ＥＥＰＲＯＭに書き込みます。");   
			 writeEEPROM(EEPROM_SIZE-64,32,mypassword);
			 writeEEPROM(EEPROM_SIZE-32,32,myssid);    
			 Serial.println("書込み完了しました。再起動すると有効になります。");
		 } else if (strncmp(buf,"subnet?",7)==0) {
			  Serial.print("subnetmask=");
			  Serial.println(WiFi.subnetMask());
		 } else if (strncmp(buf,"gateway?",8)==0) {
			  Serial.print("gatewayIP=");
			  Serial.println(WiFi.gatewayIP());
		 } else if (strncmp(buf,"scannetworks",12)==0) {
			  listNetworks();
		 } else if (strncmp(buf,"macaddress?",11)==0) {
			  showMacAddress();
		 } else if (strncmp(buf,"ipaddress?",10)==0) {
			  Serial.print("ipaddress=");
			  Serial.println(WiFi.localIP());
		 }
		 buf[0] = '\0';   
		 
	 }
	
	// Serial.println();
	 SET_E_OFF(M9038,0);
	 delayMicroseconds(500);
	}

}
////////////////////////////// Loop 終了 //////////////////////////////
void loop(){
}
