//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make    RTCRead.ino File  2020/02/17 01:26 //
////////////////////////////////////////////////////
// device_list //
 // X0037 	X0038 	X0039 	// XDevice = 3
 // // YDevice = 0 
 // // MDevice = 0  
 // D0000 	D0001 	D0002 	D0003 	D0004 	D0005 	// DDevice = 6  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <EEPROM.h>
#include "RTCRead.h";
// 0,0,34



// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


	 Serial.begin(115200);	// 通信速度：115200bps,データ長8bit,ストップビット1bit,パリティなし
// デバッグ用のシリアル通信出力 
	 Serial.begin(115200);	// 通信速度：115200bps,データ長8bit,ストップビット1bit,パリティなし
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 
	 input_refresh();		// 入力更新処理
	 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	 readEEPROM(EEPROM_SIZE-32,32,myssid); // SSIDをＥＥＰＲＯＭから読み出し
	 readEEPROM(EEPROM_SIZE-64,32,mypassword); // PASSWORDをＥＥＰＲＯＭから読み出し
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  tftInit();
	 int		count = 0;
	 Serial.println();
	 wifiFlag=0;
	 Serial.print("Connecting to ");   
	 Serial.println(myssid); 
	 WiFi.begin(myssid,mypassword); // Ｗｉｆｉを開始
	 while(WiFi.status() != WL_CONNECTED){ // 接続できない間実行
	 	 delay(500);
	 	 Serial.print(".");
	 	 count++;
	 	 if (count > 20){	// 20回トライして接続できない時
	 	 	 Serial.println("WiFi connect Error!");	// 
	 	 	 break;	// 
	 	 }
	 }
	 if (WiFi.status() == WL_CONNECTED){ // 接続が確立していれば
	 	 Serial.println(" ");	// 
	 	 Serial.println("WiFi connected");	// 
	 	 Serial.println("IP address: ");	// 
	 	 Serial.println(WiFi.localIP());	// 
	 	 wifiFlag = 1;
	 	 configTime(9 * 3600L, 0, "ntp.nict.jp", "time.google.com", "ntp.jst.mfeed.ad.jp");
	 	 getLocalTime(&ntpTimeInfo);
	 	 server.begin(); // サーバーの受信待ち開始
	 	 xTaskCreatePinnedToCore(webpage, "webserver", 4096, NULL,40, NULL,1);
	 }
	 xTaskCreatePinnedToCore(scanloop, "scanloop", 4096, NULL, 10, NULL,1);
	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void scanloop(void *args){			// 

while(1){
	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 input_refresh();		// 入力更新処理
	 tftUpdate();

	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
//00009020 00000000 00000000 00000000 00000000 00B00000
// // GYCOMT b0 D0 B1 P0 F0 L0 BIN0 11 0 
 // 行コメントの表示関数  
// GYCOMT(20) 行コメント部 
// RTC書込み
 
//00009001 00000039 00000000 00000001 00000000 00000001
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0039 0 1 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000000 00000000 00000000 00100001
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 1 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//01108051 00000099 D0002346 00000000 00000000 00B00001
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0099 D9030 11 1 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9030 = 0x99 ; 
	 } 
//01108051 00000011 D0002347 00000000 00000000 00B00002
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0011 D9031 11 2 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9031 = 0x11 ; 
	 } 
//01108051 00000030 D0002348 00000000 00000000 00B00003
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0030 D9032 11 3 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9032 = 0x30 ; 
	 } 
//01108051 00000023 D0002349 00000000 00000000 00B00004
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0023 D9033 11 4 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9033 = 0x23 ; 
	 } 
//01108051 00000059 D000234A 00000000 00000000 00B00005
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0059 D9034 11 5 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9034 = 0x59 ; 
	 } 
//01108051 00000050 D000234B 00000000 00000000 00B00006
// // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0050 D9035 11 6 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9035 = 0x50 ; 
	 } 
//0000800E 00000000 00000000 00000000 00000000 00100001
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 1 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//0000800F 2000233E 00000000 00000007 00000000 00B00007
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M9022 11 7 
 // OUT 
// OUTR(0F) 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 RTC8564Update();
	 }
	 
//00009020 00000001 00000000 00000000 00000000 00B00008
// // GYCOMT b0 D0 B1 P0 F0 L0 BIN0 11 8 
 // 行コメントの表示関数  
// GYCOMT(20) 行コメント部 
// RTC読出し
 
//00009001 00000038 00000000 00000001 00000000 00000009
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0038 0 9 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800F 2000233D 00000000 00000007 00000000 00B00009
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M9021 11 9 
 // OUT 
// OUTR(0F) 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 RTC8564Input();
	 }
	 
//00009001 2000234C 00000000 00000001 00000000 0000000A
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M9036 0 10 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9036,9036);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//0000800C 00000000 00000001 00000000 00000000 0010000A
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // MPS 
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
//00008051 D0002346 D0000000 00000000 00000000 00B0000A
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9030 D0000 11 10 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0000 = D9030 ; 
	 } 
//00008051 D0002347 D0000001 00000000 00000000 00B0000B
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9031 D0001 11 11 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0001 = D9031 ; 
	 } 
//00008051 D0002348 D0000002 00000000 00000000 00B0000C
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9032 D0002 11 12 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0002 = D9032 ; 
	 } 
//00008051 D0002349 D0000003 00000000 00000000 00B0000D
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9033 D0003 11 13 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0003 = D9033 ; 
	 } 
//00008051 D000234A D0000004 00000000 00000000 00B0000E
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9034 D0004 11 14 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0004 = D9034 ; 
	 } 
//0000800E 00000000 00000001 00000000 00000000 0010000A
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // MPP 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
//00008051 D000234B D0000005 00000000 00000000 00B0000F
// // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9035 D0005 11 15 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D0005 = D9035 ; 
	 } 
//00009001 00000037 00000000 00000001 00000000 00000010
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0037 0 16 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00108051 00000003 D000232A 00000000 00000000 00B00010
// // // // MOV b0 D0 B0 P0 F0 L1 BIN0 K0003 D9002 11 16 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9002 = 3 ; 
	 } 
//00009001 00000038 00000000 00000001 00000000 00000011
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0038 0 17 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00108051 00000002 D000232A 00000000 00000000 00B00011
// // // // MOV b0 D0 B0 P0 F0 L1 BIN0 K0002 D9002 11 17 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9002 = 2 ; 
	 } 
//00009001 00000039 00000000 00000001 00000000 00000012
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0039 0 18 
 // LD
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
//00108051 00000001 D000232A 00000000 00000000 00B00012
// // // // MOV b0 D0 B0 P0 F0 L1 BIN0 K0001 D9002 11 18 
 // MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
// MOV(51) 
	 if (aax & iix) { 
	 	 D9002 = 1 ; 
	 } 
//00009001 20001F40 00000000 00000001 00000000 00000013
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 0 19 
 //0000800C 00000000 00000002 00000000 00000000 00100013
// // MPS b0 D0 B0 P0 F0 L0 BIN0 1 19 
 //0000800F 20001F45 00000000 00000007 00000000 00B00013
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 11 19 
 //0000800E 00000000 00000002 00000000 00000000 00100013
// // MPP b0 D0 B0 P0 F0 L0 BIN0 1 19 
 //0000800F 20002134 00000000 00000007 00000000 00B00014
// // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8500 11 20 
 //00009010 00000000 00000000 00000000 00000000 00B00015
// // END b0 D0 B1 P0 F0 L0 BIN0 11 21 
 // END 
// END(10) 
//	 M5.update(); 
	 while (Serial.available() > 0){
		 recv_data[nowpos] = Serial.read();
		 if (recv_data[nowpos] == '\n'){
			 recv_data[nowpos] = '\0'; 
			 strcpy(buf,recv_data); 
			 nowpos = 0;
			 Serial.println("");
			 Serial.println(buf);
			 break;
		 }

		 nowpos++;

		 if (nowpos >= 1024) {
			  nowpos = 0;
		 }
	 }

	 if (strlen(buf) > 0) {
		 if (strncmp(buf,"ssid=",5)==0){
			 strcpy(myssid,&buf[5]);
			 Serial.println(myssid);
		 } else if (strncmp(buf,"passwd=",7)==0){
			 strcpy(mypassword,&buf[7]);
		 } else if (strncmp(buf,"ssid?",5)==0){
			 Serial.println(myssid);
		} else if (strncmp(buf,"restart",7)==0){
			 Serial.println("再起動します。");    
			 ESP.restart();
		 } else if (strncmp(buf,"wifisave",8)==0){
			 Serial.print("SSID=");
			 Serial.println(myssid);
			 Serial.print("PASSWORD=");
			 Serial.println(mypassword);
			 Serial.println("ＥＥＰＲＯＭに書き込みます。");   
			 writeEEPROM(EEPROM_SIZE-64,32,mypassword);
			 writeEEPROM(EEPROM_SIZE-32,32,myssid);    
			 Serial.println("書込み完了しました。再起動すると有効になります。");
		 } else if (strncmp(buf,"subnet?",7)==0) {
			  Serial.print("subnetmask=");
			  Serial.println(WiFi.subnetMask());
		 } else if (strncmp(buf,"gateway?",8)==0) {
			  Serial.print("gatewayIP=");
			  Serial.println(WiFi.gatewayIP());
		 } else if (strncmp(buf,"scannetworks",12)==0) {
			  listNetworks();
		 } else if (strncmp(buf,"macaddress?",11)==0) {
			  showMacAddress();
		 } else if (strncmp(buf,"ipaddress?",10)==0) {
			  Serial.print("ipaddress=");
			  Serial.println(WiFi.localIP());
		 }
		 buf[0] = '\0';   
		 
	 }
	
	// Serial.println();
	 SET_E_OFF(M9038,0);
	 delayMicroseconds(500);
	}

	
}
////////////////////////////// Loop 終了 //////////////////////////////
void loop(){
}
