﻿#include "renri_enco.h"



RENRI_ENCO::RENRI_ENCO(int in_pin,int ctrl_pin,int unit_no){
  enc_init(in_pin,ctrl_pin,unit_no);
  
  return ;
}

void RENRI_ENCO::enc_init(int in_pin,int ctrl_pin,int unit_no){
  cnt_no = (pcnt_unit_t)unit_no;
  pcnt_config_t phaseA; // 

        phaseA.pulse_gpio_num = in_pin;
        phaseA.ctrl_gpio_num = ctrl_pin;
        phaseA.unit = cnt_no;

        phaseA.lctrl_mode = PCNT_MODE_REVERSE;
        phaseA.hctrl_mode = PCNT_MODE_KEEP;
        phaseA.channel = PCNT_CHANNEL_0;
        phaseA.pos_mode = PCNT_COUNT_INC;
        phaseA.neg_mode = PCNT_COUNT_DEC;
        phaseA.counter_h_lim = 0;
        phaseA.counter_l_lim = 0;

  pcnt_config_t phaseB;

        phaseB.pulse_gpio_num = ctrl_pin;
        phaseB.ctrl_gpio_num = in_pin;
        phaseB.unit = cnt_no;

        phaseB.lctrl_mode = PCNT_MODE_KEEP;
        phaseB.hctrl_mode = PCNT_MODE_REVERSE;
        phaseB.channel = PCNT_CHANNEL_1;
        phaseB.pos_mode = PCNT_COUNT_INC;
        phaseB.neg_mode = PCNT_COUNT_DEC;
        phaseB.counter_h_lim = 0;
        phaseB.counter_l_lim = 0;
  
  pcnt_unit_config(&phaseA); // 
  pcnt_unit_config(&phaseB); // 

  return ;
}

void RENRI_ENCO::enc_clear(){
  pcnt_counter_clear(cnt_no);
}

void RENRI_ENCO::enc_pause(){
  pcnt_counter_pause(cnt_no);
}

void RENRI_ENCO::enc_start(){
  pcnt_counter_resume(cnt_no);
}

void RENRI_ENCO::enc_stop(){
  pcnt_counter_pause(cnt_no);
}
int16_t RENRI_ENCO::getCount(){
  pcnt_get_counter_value(cnt_no, &hcount);
  return hcount;
}
