﻿// renri_enco.h

#ifndef RENRI_ENCO_H_INCLUDE
#define RENRI_ENCO_H_INCLUDE

#if defined(ARDUINO) && ARDUINO >= 100
	#include "Arduino.h"
#else
	#include "WProgram.h"
#endif

#include "driver/pcnt.h"

// RENRI_ENCOは、２ユニット分を想定して作る

class RENRI_ENCO{
  public:
    RENRI_ENCO(int in_pin,int ctrl_pin,int unit_no);	// in_pin:A相 ctrl_pin:Ｂ相 ユニットＮＯ:0-7任意
    void enc_init(int in_pin,int ctrl_pin,int unit_no);
    int16_t getCount();
    void enc_clear(); // カウンタの初期化
    void enc_pause(); // カウンタ動作の一時停止
    void enc_start(); // カウンタ動作の開始
    void enc_stop();  // カウンタ動作の一時停止

  private:
    pcnt_unit_t    cnt_no  = PCNT_UNIT_0; // PCNT_UNIT_0 = 0,PCNT_UNIT_1 = 1,PCNT_UNIT_2 = 2,PCNT_UNIT_3 = 3,PCNT_UNIT_4 = 4,PCNT_UNIT_5 = 5,PCNT_UNIT_6 = 6,PCNT_UNIT_7 = 7,PCNT_UNIT_MAX, 
    int16_t hcount   = 0;   //カウント数(カウント数を取得する変数)
};


#endif
