﻿#include "renri_hcnt.h"

RENRI_HCNT* pdata[8];

RENRI_HCNT::RENRI_HCNT(){
  return;
}

RENRI_HCNT::RENRI_HCNT(int in_pin,int out_pin,int16_t count,int unit_no){
  hcnt_init(in_pin,out_pin,count,unit_no);
  
  return ;
}

void RENRI_HCNT::hcnt_init(int in_pin,int out_pin,int16_t count,int unit_no){
  cnt_no = (pcnt_unit_t)unit_no;
  outpin_no = out_pin;
  pinMode(outpin_no,OUTPUT);
  output = 0;
  pdata[cnt_no] = this;

  pcnt_intr_disable(cnt_no);

  pcnt_config_t cnt_config; // 

    cnt_config.pulse_gpio_num = in_pin;
    cnt_config.ctrl_gpio_num = PCNT_PIN_NOT_USED;
    cnt_config.unit = cnt_no;

    cnt_config.lctrl_mode = PCNT_MODE_KEEP;
    cnt_config.hctrl_mode = PCNT_MODE_DISABLE;
    cnt_config.channel = PCNT_CHANNEL_0;
    cnt_config.pos_mode = PCNT_COUNT_INC;
    cnt_config.neg_mode = PCNT_COUNT_DIS;
    cnt_config.counter_h_lim = count;
    cnt_config.counter_l_lim = 0;
  
  pcnt_unit_config(&cnt_config); // 

  pcnt_evt_queue = xQueueCreate(10, sizeof(pcnt_evt_t));
  pcnt_set_event_value(cnt_no, PCNT_EVT_THRES_1,1);
  pcnt_event_enable(cnt_no, PCNT_EVT_THRES_1);
  pcnt_event_enable(cnt_no, PCNT_EVT_H_LIM);
  pcnt_isr_register(cnt_no_intr_handler, NULL, 0, &user_isr_handle);
  pcnt_intr_enable(cnt_no);
  starttime =  micros(); ;

  return ;
}

// ＯＮ幅測定関数
void RENRI_HCNT::pcnt_init(int in_pin, int out_pin, int16_t count, int unit_no){
  cnt_no = (pcnt_unit_t)unit_no;
  outpin_no = out_pin;
  output = 0;

  pdata[cnt_no] = this;
  
  pinMode(outpin_no, OUTPUT);

  pcnt_intr_disable(cnt_no);

  pcnt_config_t cnt_config1;

  cnt_config1.pulse_gpio_num = in_pin;
  cnt_config1.ctrl_gpio_num = PCNT_PIN_NOT_USED;
  cnt_config1.unit = cnt_no;

  cnt_config1.lctrl_mode = PCNT_MODE_KEEP;
  cnt_config1.hctrl_mode = PCNT_MODE_DISABLE;
  cnt_config1.channel = PCNT_CHANNEL_0;
  cnt_config1.pos_mode = PCNT_COUNT_INC;
  cnt_config1.neg_mode = PCNT_COUNT_DIS;

  cnt_config1.counter_h_lim = 0;
  cnt_config1.counter_l_lim = 0;

  pcnt_config_t cnt_config2;

  cnt_config2.pulse_gpio_num = in_pin;
  cnt_config2.ctrl_gpio_num = PCNT_PIN_NOT_USED;
  cnt_config2.unit = cnt_no;

  cnt_config2.lctrl_mode = PCNT_MODE_KEEP;
  cnt_config2.hctrl_mode = PCNT_MODE_DISABLE;
  cnt_config2.channel = PCNT_CHANNEL_1;

  cnt_config2.pos_mode = PCNT_COUNT_DIS;
  cnt_config2.neg_mode = PCNT_COUNT_DEC;

  cnt_config2.counter_h_lim = 0;
  cnt_config2.counter_l_lim = 0;

  pcnt_unit_config(&cnt_config1); //
  pcnt_unit_config(&cnt_config2); //

  pcnt_evt_queue = xQueueCreate(10, sizeof(pcnt_evt_t));
  pcnt_set_event_value(cnt_no, PCNT_EVT_THRES_1,1);
  pcnt_event_enable(cnt_no, PCNT_EVT_THRES_1);
  pcnt_set_event_value(cnt_no, PCNT_EVT_THRES_0,0);
  pcnt_event_enable(cnt_no, PCNT_EVT_THRES_0);

  pcnt_isr_register(cnt_no_intr_handler, NULL, 0, &user_isr_handle);
  pcnt_intr_enable(cnt_no);  

  pmode = 0;

  return ;  
}


// パルスの周期とＨＩＧＨ時間の測定（デューティ比の測定）
void RENRI_HCNT::dcnt_init(int in_pin, int out_pin, int16_t count, int unit_no){
  cnt_no = (pcnt_unit_t)unit_no;
  outpin_no = out_pin;
  output = 0;

  pdata[cnt_no] = this;
  
  pinMode(outpin_no, OUTPUT);

  pcnt_intr_disable(cnt_no);

  pcnt_config_t cnt_config1;

  cnt_config1.pulse_gpio_num = in_pin;
  cnt_config1.ctrl_gpio_num = PCNT_PIN_NOT_USED;
  cnt_config1.unit = cnt_no;

  cnt_config1.lctrl_mode = PCNT_MODE_KEEP;
  cnt_config1.hctrl_mode = PCNT_MODE_DISABLE;
  cnt_config1.channel = PCNT_CHANNEL_0;
  cnt_config1.pos_mode = PCNT_COUNT_INC;
  cnt_config1.neg_mode = PCNT_COUNT_INC;
  cnt_config1.counter_h_lim = 3;
  cnt_config1.counter_l_lim = 0;

  pcnt_unit_config(&cnt_config1); //

  pcnt_evt_queue = xQueueCreate(10, sizeof(pcnt_evt_t));
  pcnt_set_event_value(cnt_no, PCNT_EVT_THRES_1,1);
  pcnt_event_enable(cnt_no, PCNT_EVT_THRES_1);
  pcnt_set_event_value(cnt_no, PCNT_EVT_THRES_0,2);
  pcnt_event_enable(cnt_no, PCNT_EVT_THRES_0);
  pcnt_event_enable(cnt_no, PCNT_EVT_H_LIM);
  pcnt_isr_register(cnt_no_intr_handler, NULL, 0, &user_isr_handle);
  pcnt_intr_enable(cnt_no);  
  pmode = 1;  // デューティ比測定モード
  return ;  
}

void RENRI_HCNT::hcnt_clear(){
  pcnt_counter_clear(cnt_no);
}

void RENRI_HCNT::hcnt_pause(){
  pcnt_counter_pause(cnt_no);
  output=0;
  digitalWrite(outpin_no, LOW);
}

void RENRI_HCNT::hcnt_start(){
  digitalWrite(outpin_no, HIGH);
  output=1;

  pcnt_counter_resume(cnt_no);
}

void RENRI_HCNT::pcnt_start() {
  hcnt_pause();
  hcnt_clear();  
  starttime=0; endtime=0;
  digitalWrite(outpin_no, HIGH);
  output=1;
  pcnt_counter_resume(cnt_no);
}

void RENRI_HCNT::dcnt_start() {
  hcnt_pause();
  hcnt_clear();  
  starttime=0; endtime=0; dtime=0;
  digitalWrite(outpin_no, HIGH);
  output=1;
  pcnt_counter_resume(cnt_no);
}

void RENRI_HCNT::hcnt_stop(){
  pcnt_counter_pause(cnt_no);
  digitalWrite(outpin_no, LOW);
  output=0;
}

void RENRI_HCNT::EnableInterrupt(){
  hcnt_start();
}

int16_t RENRI_HCNT::getCount(){
  pcnt_get_counter_value(cnt_no, &hcount);
  return hcount;
}

uint32_t RENRI_HCNT::hcnt_getTimeLength(){
  return endtime-starttime;
}

uint32_t RENRI_HCNT::hcnt_getdTimeLength(){
  return dtime-starttime;
}

extern "C" {
  void IRAM_ATTR cnt_no_intr_handler(void *arg)
  {
    uint32_t intr_status = PCNT.int_st.val;
    int i;
    pcnt_evt_t evt;
    portBASE_TYPE HPTaskAwoken = pdFALSE;

    for (i = 0; i < PCNT_UNIT_MAX; i++) {
      if (intr_status & (BIT(i))) {
        evt.unit = i;
        evt.status = PCNT.status_unit[i].val;

        if(evt.status &  PCNT_STATUS_H_LIM_M){
          if (pdata[i]->pmode==1){
            pdata[i]->endtime = micros();
          } else {
            pdata[i]->endtime = micros();
          }
          pdata[i]->hcnt_stop();
        }
        if(evt.status & PCNT_STATUS_THRES1_M){
          pdata[i]->starttime = micros();
        }
        if(evt.status & PCNT_STATUS_THRES0_M){
          if(pdata[i]->pmode==0){
            pdata[i]->endtime = micros();
            pdata[i]->hcnt_stop();
          } else {
            pdata[i]->dtime = micros();
          }
        }
        if(evt.status & PCNT_STATUS_ZERO_M){
          pdata[i]->hcnt_stop();          
        }
        if(evt.status & PCNT_STATUS_L_LIM_M){
        }


        PCNT.int_clr.val = BIT(i);
        xQueueSendFromISR(pdata[i]->pcnt_evt_queue, &evt, &HPTaskAwoken);
        if (HPTaskAwoken == pdTRUE) {
          portYIELD_FROM_ISR();
        }
      }
    }
  }
}