﻿// renri_hcnt.h

#ifndef RENRI_HCNT_H_INCLUDE
#define RENRI_HCNT_H_INCLUDE

#if defined(ARDUINO) && ARDUINO >= 100
	#include "Arduino.h"
#else
	#include "WProgram.h"
#endif

#include "driver/pcnt.h"

#ifndef RENRI_HCNT_IRQ
  #define RENRI_HCNT_IRQ
  extern "C" {
  void IRAM_ATTR cnt_no_intr_handler(void *arg);
  }
#endif

// RENRI_HCNTは、高速カウンタを想定して定義している

typedef struct {
    int unit;  // 
    uint32_t status; // 
} pcnt_evt_t;

class RENRI_HCNT{
  public:
    RENRI_HCNT();

    RENRI_HCNT(int in_pin,int out_pin,int16_t count=0,int unit_no=0);	// in_pin:カウント入力 out_pin:カウントアップ出力 ユニットＮＯ:0-7任意
    void hcnt_init(int in_pin,int out_pin,int16_t count=0,int unit_no=0); // in_pin:カウント入力 out_pin:カウントアップ出力 ユニットＮＯ:0-7任意
    int16_t getCount();
    void hcnt_clear(); // カウンタの初期化
    void hcnt_pause(); // カウンタ動作の一時停止
    void hcnt_start(); // カウンタ動作の開始
    void hcnt_stop();  // カウンタ動作の一時停止
    uint32_t hcnt_getTimeLength(); // 周期又はＯＮ時間[us]を取得する関数（開始から終了までの時間）
    uint32_t hcnt_getdTimeLength(); // デューティ比のもととなるＯＮ時間[us]を取得する関数

    // ON幅測定の関数
    void pcnt_start();
    void pcnt_init(int in_pin,int out_pin,int16_t count,int unit_no);

    // デューティ測定の関数
    void dcnt_start();
    void dcnt_init(int in_pin,int out_pin,int16_t count,int unit_no);


    pcnt_unit_t    cnt_no  = PCNT_UNIT_0; // PCNT_UNIT_0 = 0,PCNT_UNIT_1 = 1,PCNT_UNIT_2 = 2,PCNT_UNIT_3 = 3,PCNT_UNIT_4 = 4,PCNT_UNIT_5 = 5,PCNT_UNIT_6 = 6,PCNT_UNIT_7 = 7,PCNT_UNIT_MAX, 

    int outpin_no;
    byte output;

    uint32_t starttime;	// 開始時間を格納する変数
    uint32_t endtime;	// 終了時間を格納する変数
    uint32_t dtime;	// 立上り後、立下りが来た時間を格納する変数
    byte pmode;		// 0:ＯＮ幅測定 1:デューティ比測定


    xQueueHandle pcnt_evt_queue;   // A queue to handle pulse counter events
    pcnt_isr_handle_t user_isr_handle = NULL; //user's ISR service handle
    void EnableInterrupt();

  protected:
    
  private:
    int16_t hcount   = 0;   //カウント数(カウント数を取得する変数)
};


#endif